<template>
    <div>

        <!-- eslint-disable -->
    
        <!--Modals-->
        <BoxCreateModal ref="refBoxCreateModal" @boxSave="boxSave" />
        <!-- <SendGuideModal ref="refSendGuideModal"/> -->
    
        <v-row>
            <v-col cols="12" sm="6">
                <v-row>
                    <v-col cols="12">
                        <p class="font-weight-regular">
                            Lios
                        </p>
                    </v-col>
                    
                </v-row>
    
                <v-row
                    align="center"
                    justify="start"
                >
    
                    <v-col
                        v-for="(lios, index) in liosArray"
                        :key="index"
                    >
    
                        <v-chip
                            close
                            @click:close="removeLio(index)"
                        >
                            <v-icon
                                left
                            >
                                mdi-package-variant-closed-plus
                            </v-icon>
                            
                            {{lios.slug}}
    
                        </v-chip>
                    </v-col>
    
                </v-row>
    
                <v-row>
                    <v-col cols="12">
                        <p class="font-weight-regular">
                            Cajas restantes
                        </p>
                    </v-col>
                    
                </v-row>
                <v-row
                    align="center"
                    justify="start"
                >
    
                    <v-col
                        v-for="(box, index) in boxesArray"
                        :key="box.orderNumber"
                    >
    
                        <v-chip
                            close
                            @click="addSelectedBoxes(index)"
                            @click:close="removeBox(index)"
                        >
                            <v-icon
                                left
                            >
                                mdi-package-variant-closed-plus
                            </v-icon>
                            
                            {{box.slug}}
    
                        </v-chip>
                    </v-col>
    
                </v-row>
    
            </v-col>
    
            <v-col cols="12" sm="6">
                <v-list>
                    <v-subheader>Crear lio</v-subheader>
                    <v-list-item
                        v-for="(item, index) in selectedBoxes"
                        :key="item.orderNumber"
                        @click="removeSelectedBoxes(index)"
                    >
                        <v-list-item-avatar>
                            <v-icon
                            >
                                mdi-package-variant-closed-minus
                            </v-icon>
                        </v-list-item-avatar>
                        <v-list-item-title v-text="item.slug"></v-list-item-title>
                    </v-list-item>
    
                </v-list>
    
                <v-btn
                    color="primary"
                    small
                    @click="createLio()"
                >
                    <v-icon dark>
                        mdi-plus
                    </v-icon> 
                    Crear Lio
                </v-btn>
    
            </v-col>
        </v-row>
        <v-row>
            <v-col cols="12">
                <v-data-table
                    :headers="headers"
                    :items="items"
                    :footer-props="{ disablePagination : true, disableItemsPerPage : true }"
                    :disable-sort="true"
                    hide-default-footer
                >
    
                </v-data-table>
    
            </v-col>
        </v-row>
        <v-row>
            <v-col cols="6" class="d-flex justify-center">
                <v-btn
                    color="primary"
                    class="mr-3"
                    small
                    @click="createBox(0)"
                    :disabled="buttonSend"
                >
                    <v-icon dark>
                        mdi-plus
                    </v-icon> 
                    Añadir Caja
                </v-btn>
            </v-col>
            <v-col cols="6" class="d-flex justify-center">
                <v-btn
                    color="primary"
                    class="mr-3"
                    small
                    @click="createBox(1)"
                    :disabled="buttonSend"
                >
                    <v-icon dark>
                        mdi-plus
                    </v-icon> 
                    Añadir Tubo
                </v-btn>
            </v-col>
        </v-row>
    
        <v-row class="mb-10">
            <v-col cols="6">
    
            </v-col>
            <v-col cols="6" class="d-flex justify-center">
                <v-btn 
                    @click="sendPackages()"
                    :disabled="!buttonSend || spinner"
                    >
                    <span>Enviar</span>

                    <template v-if="spinner">
                        <div class="d-flex justify-center">
                            <v-progress-circular
                                :size="20"
                                color="primary"
                                indeterminate
                            ></v-progress-circular>
                        </div>
                    </template>
                    <template v-else>
                        <v-icon>mdi-cube-send</v-icon>
                    </template>

                </v-btn>
            </v-col>
        </v-row>
    </div>

</template>

<script setup>
    import { ref, reactive, onMounted, onUnmounted } from 'vue';
    import { HttpReq } from '@/utilies/httpRequest';
    import store from '@/store';
    import router from '@/router';
    import BoxCreateModal  from '@/components/BoxCreateModal.vue';
    /* import SendGuideModal from '@/components/SendGuideModal.vue'; */

    const props = defineProps(['data', 'totalPrice'])

    const spinner = ref(false)

    const items = ref([])
    const refBoxCreateModal = ref(null)
    //const refSendGuideModal = ref(null)

    const headers = ref([
        {
            text: '# Orden',
            align: 'start',
            value: 'orderNumber'
        },
        {
            text: 'Cantidad',
            value: 'amount'
        },
        {
            text: 'Producto',
            value: 'product'
        },
        {
            text: 'Fecha de entrega',
            value: 'dateOrder'
        }
    ])

    const boxesArray = ref([])
    const liosArray = ref([])
    const orderNumbers = ref([])
    const invoice = ref(null)

    const selectedBoxes = ref([])

    const buttonSend = ref(false)

    const cancelOrdersBoxes = ref(true)

    onMounted(() => {
        /* console.log("props.data: ", props.data)
        console.log("props.totalPrice: ", props.totalPrice) */
        let codeShip = null

        let ordersData = props.data

        if(ordersData.length>0){
            codeShip = ordersData[0].orders[0].codeOffice
            store.commit('setShipping', codeShip)
        }

        items.value = ordersData.map(orderItem => {
            
            orderItem.orders.map(item => {
                item.count = 0
            })

            return orderItem.orders
        }).flat()

        invoice.value = items.value[0].invoice
    })

    onUnmounted(() => {
        if(cancelOrdersBoxes.value)
            cancelPackage()
    })

    async function cancelPackage() {
        let arrayDocNums = props.data.map(item => {
            return item.orders.map(item2 => item2.orderNumber)
        }).flat()
        let resp = await HttpReq.postData(arrayDocNums, 'data/docnumsdelete')
    }

    function createBox(modeBox) {
        console.log("createBox: ", items.value)
        refBoxCreateModal.value.openModal([...items.value], [...boxesArray.value.map(item => item.products)], modeBox)
    }

    function boxSave(newBox = []) {
        if(newBox.length <= 0 )
            return
        
        boxesArray.value.push(newBox)

        newBox.products.forEach((product) => {
            if(!orderNumbers.value.find(item => item == product.orderNumber))
                orderNumbers.value.push(product.orderNumber)
        })
        for (const number in newBox.orderNumberRepeat) {
            let index = items.value.findIndex(item => item.orderNumber == number)
            if(index != -1) {
                items.value[index].count +=  newBox.orderNumberRepeat[number]
                items.value[index].amount -= newBox.orderNumberRepeat[number]
            }
        }
        let p = 0
        items.value.forEach(item => {
            p += item.amount
        })
        buttonSend.value = p <= 0 ? true : false
        return
    }

    function addSelectedBoxes(index) {
        selectedBoxes.value.push(boxesArray.value[index])
        boxesArray.value = boxesArray.value.filter((value, indexTemp) => {
            return indexTemp != index
        })
    }

    function removeSelectedBoxes(index) {
        boxesArray.value.push(selectedBoxes.value[index])
        selectedBoxes.value = selectedBoxes.value.filter((value, indexTemp) => {
            return indexTemp != index
        })
    }

    function removeBox(indexBoxesArray) {
        for (const orderNumber in boxesArray.value[indexBoxesArray].orderNumberRepeat) {
            let index = items.value.findIndex(item => item.orderNumber == orderNumber)

            if(index != -1) {
                items.value[index].count -=  boxesArray.value[indexBoxesArray].orderNumberRepeat[orderNumber]
                items.value[index].amount += boxesArray.value[indexBoxesArray].orderNumberRepeat[orderNumber]
            }
        }

        boxesArray.value = [...boxesArray.value.filter((item, indexTemp) => {
            return indexTemp != indexBoxesArray
        })]

        buttonSend.value = false

    }

    function createLio() {
        let finalWidth = 0
        let finalHeight = 0
        let finalWeight = 0
        let finalLong = 0

        let slug = ''
        let products = []
        selectedBoxes.value.forEach(item => {
            if(item.height > finalHeight)
                finalHeight = item.height
            if(item.long > finalLong)
                finalLong = item.long
            if(item.width > finalWidth)
                finalWidth = item.width
            finalWeight += parseFloat(item.weight)
            products = products.concat(item.products)
            let slugSplit = item.slug.split('--')
            slug +=  slugSplit[0]+" "
        })

        slug += `-${finalHeight}x${finalWidth}x${finalLong}-${finalWeight}`

        if(products.length > 0) {
            liosArray.value.push({
                height: finalHeight,
                long: finalLong,
                width: finalWidth,
                weight: finalWeight,
                products: products,
                slug: slug,
                backup: [...selectedBoxes.value]
            })
            selectedBoxes.value = []
        }
    }

    function removeLio(index) {
        let backupBox = liosArray.value[index].backup
        if(backupBox.length > 0) {
            boxesArray.value = [...boxesArray.value.concat(backupBox)]
            liosArray.value = [...liosArray.value.filter((item, indexTemp) => indexTemp != index)]
        }
    }

    function shippingSafraCoordinadora(shippingType) {
        if(shippingType == 1 || shippingType ==4)
            return 1
        if(shippingType == 3) 
            return 2
        return 0
    }

    async function sendPackages() {
        spinner.value = true
        let boxes = liosArray.value.concat(boxesArray.value)

        let textOneObservation = ""
        let textTwoObservation = ""
        let quantityLios = 0
        let quantityBox = 0
        let unitsLios = 0
        let quantityTubo = 0
        
        let objectContents = {}
        let textContent = ""

        items.value.forEach(item => {
            textOneObservation += item.orderNumber+"*"+item.count+"-"
            if(objectContents.hasOwnProperty(item.productName))
                objectContents[item.productName] = objectContents[item.productName] + item.count
            else
                objectContents[item.productName]=item.count
        })
        //let unitsBox = 0
        boxes.forEach(box => {

            if(box.width == 20) {
                quantityTubo++
                return
            }

            if(box.backup) {
                quantityLios++
                unitsLios += box.products.length
            } else {
                quantityBox++
                //unitsBox += box.products.length
            }

            
        })
        if(quantityLios > 0)
            textTwoObservation = `${quantityLios}LIO${quantityLios == 1 ? '' : 'S'}X${unitsLios}`
        if(quantityBox > 0)
            textTwoObservation += `+${quantityBox}CAJA${quantityBox == 1 ? '' : 'S'}`
        if(quantityTubo > 0)
            textTwoObservation += `+${quantityTubo}TUBO${quantityTubo == 1 ? '' : 'S'}`
        
        for (const keyContent in objectContents) {
            textContent += `${keyContent}X${objectContents[keyContent]}-`
        }
        /* console.log("textContent: ", textContent);
        console.log("textOneObservation: ", textOneObservation)
        console.log("textTwoObservation: ", textTwoObservation)
        console.log("textContents: ", objectContents) */
        let data = {
            operatorName: store.getters.getUser,
            date: new Date(Date.now()).toISOString(),
            state: 0,
            boxes: boxes.map(item => {
                return {
                    height: item.height,
                    width: item.width,
                    longer: item.long,
                    weight: item.weight,
                    quantity: 1,
                    reference: item.slug,
                    packageName: item.width == 20 ? 'Tubo' : (item.backup ? 'Lio' : 'Caja')
                }
            }),
            orderNumbers: orderNumbers.value,
            invoice: invoice.value,

            declaredValue: props.totalPrice,
            serviceLevel: shippingSafraCoordinadora(store.getters.getShipping),
            contents: textContent.substring(0, textContent.length-1),
            observation:  `REF:${textOneObservation.substring(0, textOneObservation.length-1)} / ${textTwoObservation}`
        }

        let resp = await HttpReq.postData(data, "package")

        if(resp.status == 201) {
            cancelOrdersBoxes.value = false
            router.replace({name: 'operator'})
        } else {
            spinner.value = false
            store.dispatch('openModal', {
                title: "Estado envio",
                body: "¡No se pudo enviar los datos al servidor, serás redirigido a la página de inicio en 7 segundos!",
                type: 2
            })
            setTimeout(() => {
                store.dispatch('closeModal')
                router.replace({name: 'operator'})
            }, 7000);
        }
    }
</script>

<style>

</style>